<?php
// $Id: views_handler_adly.inc,v 1.1.2.2 2010/09/27 02:44:41 inadarei Exp $
/**
 * @file
 * Contains the adly style plugin.
 */
 
 
 /**
 * Inject ad.ly ads!
 */
class views_handler_adly extends views_handler_sort {
  function query() {
  }

 	/**
  * Set default options
  */
  function option_definition() {
    //$options = parent::option_definition();

    $options['adly_position'] = array('default' => 'top');
    $options['adly_content_field'] = array('default' => 'node_title');
    $options['adly_author_field'] = array('default' => 'author');

    return $options;
  }
  
   /**
   * Render the given filter's form.
   */
  function options_form(&$form, &$form_state) {
    //parent::options_form($form, $form_state);
    $form['adly_position'] = array(
      '#type' => 'radios',
      '#title' => t('Ad.ly Ads Position'),
      '#options' => array('top' => t('At the Top [$attachment_before tpl variable]'), 
      										'bottom' => t('At the Bottom [$attachment_after tpl variable]')),
      '#default_value' => $this->options['adly_position'],
    );
        
    $options_fields = $this->_get_views_fields();


    $form['adly_content_field'] = array(
      '#title' => t('Field containing the most important content [Usually: title or body]'),
      '#type' => 'select',
      '#options' => $options_fields,
      '#multiple' => FALSE,
      '#required' => TRUE,
      '#default_value' => $this->options['adly_content_field'],
    );

    $form['adly_author_field'] = array(
      '#title' => t('Field containing Author Name [if available]'),
      '#type' => 'select',
      '#options' => $options_fields,
      '#multiple' => FALSE,
      '#required' => FALSE,
      '#default_value' => $this->options['adly_author_field'],
    );
    
  }
  
  function admin_summary() {
    switch ($this->options['adly_position']) {
      case 'top':
      default:
        $type = t('Top');
        break;
      case 'bottom';
        $type = t('Bottom');
        break;
    }
    return '<span class="views-ascending"><span>' . $type . '</span></span>';
  }
  
  
  
  
  function _get_views_fields($just_aliases=FALSE) {
  
  	
    $curr_disp = $this->view->current_display;
    $handlers = $this->view->display[$curr_disp]->handler->get_handlers('field');

  	//$items = $this->view->get_items('field', $curr_disp);
  	//dpm($items);


    $avail_fields = array();
    if (is_array($handlers)) {
      foreach ($handlers as $key => $val) {
        if ($key == 'views_sql_groupedfields') continue; // May not select groupby fields!

        $unique_id = $val->options['id'];

        if ($just_aliases) {
          $avail_fields[] = $val->field_alias;
          continue;
        }

        $field_alias = $val->options['table'] . '_' . $val->options['field'];
        $relationship = '';

        $all_relationships = $this->_get_relationships ();
        $rel = $val->options['relationship']; 
        $rel = $all_relationships[$rel];

        if (!empty($rel)) {
          $field_name = $rel->fieldprefix . '.' . $val->options['field']; // Reserved, not used.
          $field_alias = $rel->fieldprefix . '_' . $val->options['field'];
          $relationship = (empty($rel)) ? '' : '[' . $rel->label . '] ';
        }

        $field_name = $relationship . $val->definition['group'] . ': ' . $val->definition['title'];
        $avail_fields[$unique_id] = $field_name;
      }
    }

    return $avail_fields;
  }


  function _get_relationships() {
    $default_rels = array();
    $curr_disp_rels = array();

    $curr_disp = $this->view->current_display;

    $default_rels = $this->view->display['default']->handler->options['relationships'];
    $curr_displ_rels = $this->view->display[$curr_disp]->handler->options['relationships'];

    $default_rels = (is_array($default_rels)) ? $default_rels : array();
    $curr_displ_rels = (is_array($curr_displ_rels)) ? $curr_displ_rels : array();

    $relationships = array_merge($default_rels, $curr_displ_rels);

    $all_rels = array();
    $base_table = $this->view->base_table;

    if (is_array($relationships)) {
      foreach ($relationships as $key => $val) {
        $obj = new stdClass();
        $obj->fieldprefix = $base_table . '_' . $val['table'];
        $obj->label = $val['label'];
        $obj->table = $val['table'];
        $obj->field = $val['field'];
        $all_rels[$key] = $obj;
      }
    }

    return $all_rels;
    
  }
}
